// -*- c++ -*-
#ifndef REGION_H
#define REGION_H

#include <flux/machine/types.h>

#include "lock.h"
#include "oskit/amm.h"

// define a Fiasco-specific allocator class usable together with class slab

class region {
public:
  static void init();

  static vm_offset_t reserve_pages(vm_size_t size, unsigned long alignment);
  static void return_pages(vm_offset_t addr, vm_size_t size);

private:
  friend class jdb;

  static void debug_dump();
};


#endif
