/*
 * $Id: rmgr_stubs.c,v 1.3 1999/04/29 12:29:55 hohmuth Exp $
 */

/*****************************************************************************
 * liboskit_support/src/rmgr_stubs.h                                         *
 * RMGR stub functions, they are used if no RMGR is used and are overwritten *
 * by librmgr.                                                               *
 *****************************************************************************/

/* l4 includes */
#include <l4/sys/types.h>

/* oskit includes */
#include <stdio.h>

l4_threadid_t rmgr_pager_id __attribute__ ((weak));

int rmgr_init(void) __attribute__ ((weak));

int rmgr_init(void)
{
  /* no RMGR present */
  return 0;
}
