
/*  A Bison parser, made from cfg-parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TASK	258
#define	MODNAME	259
#define	CHILD	260
#define	IRQ	261
#define	MAX	262
#define	IN	263
#define	MASK	264
#define	MEMORY	265
#define	HIMEM	266
#define	LOGMCP	267
#define	BOOTMCP	268
#define	BOOTPRIO	269
#define	BOOTWAIT	270
#define	RMGR	271
#define	SIGMA0	272
#define	DEBUGFLAG	273
#define	VERBOSE	274
#define	LOG	275
#define	SMALLSIZE	276
#define	SMALL	277
#define	BOOTSMALL	278
#define	MODULE	279
#define	TASK_PROTO	280
#define	TASK_ALLOC	281
#define	TASK_GET	282
#define	TASK_FREE	283
#define	TASK_CREATE	284
#define	TASK_DELETE	285
#define	TASK_SMALL	286
#define	TASK_GET_ID	287
#define	TASK_CREATE_WITH_PRIO	288
#define	MEM_PROTO	289
#define	MEM_FREE	290
#define	MEM_FREE_FP	291
#define	IRQ_PROTO	292
#define	IRQ_GET	293
#define	IRQ_FREE	294
#define	RMGR_PROTO	295
#define	RMGR_PING	296
#define	LOG_IT	297
#define	KDEBUG	298
#define	UNSIGNED	299
#define	STRING	300

#line 3 "cfg-parse.y"

#include <unistd.h>

#include <l4/rmgr/proto.h>

#include "quota.h"
#include "init.h"
#include "rmgr.h"
#include "cfg.h"

#define yyparse __cfg_parse

static void yyerror(const char *s);

unsigned __cfg_task;
static unsigned ctask;

static int assert_mod = -1;

static unsigned c_max = -1, c_low = 0, c_high = -1, c_mask = 0xffffffff;

#ifndef min
#define min(x,y) ((x)<(y)?(x):(y))
#endif
#ifndef max
#define max(x,y) ((x)>(y)?(x):(y))
#endif

#define minset(x, y) ((x) = min((x),(y)))
#define maxset(x, y) ((x) = max((x),(y)))

#define SET_DEBUG_OPT(proto, action) 					\
	do {								\
		debug_log_mask |= (1L << proto);			\
		if (action)						\
			debug_log_types = (2L | (action << 16) | 	\
					   (debug_log_types & 7));	\
	} while(0);

#line 43 "cfg-parse.y"
typedef union {
  char *string;
  unsigned number;
  struct {
    unsigned low, high;
  } interval;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		100
#define	YYFLAG		-32768
#define	YYNTBASE	49

#define YYTRANSLATE(x) ((unsigned)(x) <= 300 ? yytranslate[x] : 78)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    47,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    46,     2,    48,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,    10,    12,    14,    17,    20,    22,
    24,    26,    28,    30,    32,    34,    36,    38,    40,    42,
    44,    46,    48,    50,    52,    54,    56,    58,    61,    63,
    65,    67,    69,    71,    73,    76,    79,    80,    83,    85,
    87,    90,    93,    96,    99,   102,   105,   106,   109,   112,
   113,   116,   119,   122,   125,   128,   131,   134,   137,   140,
   142,   144,   146,   148,   150,   153,   155,   158,   161,   167,
   169,   172,   174
};

static const short yyrhs[] = {    50,
     0,    51,    50,     0,     0,    61,    65,    58,     0,    52,
     0,    57,     0,    21,    76,     0,    76,    76,     0,    25,
     0,    26,     0,    27,     0,    28,     0,    29,     0,    30,
     0,    31,     0,    32,     0,    33,     0,    34,     0,    35,
     0,    36,     0,    37,     0,    38,     0,    39,     0,    40,
     0,    41,     0,    42,     0,    43,     0,    54,    55,     0,
    54,     0,    53,     0,    55,     0,    15,     0,    19,     0,
    18,     0,    20,    56,     0,    59,    58,     0,     0,    60,
    63,     0,    24,     0,     3,     0,     3,    62,     0,     3,
    16,     0,     3,    17,     0,     3,    76,     0,     4,    77,
     0,    64,    63,     0,     0,     4,    77,     0,    66,    65,
     0,     0,     5,    67,     0,    10,    69,     0,    11,    69,
     0,     6,    70,     0,    22,    68,     0,    12,    76,     0,
    13,    76,     0,    14,    76,     0,    23,    76,     0,    71,
     0,    71,     0,    71,     0,    71,     0,    74,     0,    72,
    71,     0,    72,     0,     7,    76,     0,     8,    73,     0,
    46,    76,    47,    76,    48,     0,    75,     0,     9,    76,
     0,    44,     0,    45,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    68,    71,    72,    75,   107,   108,   111,   113,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
   128,   129,   130,   131,   132,   133,   134,   137,   138,   141,
   142,   145,   146,   147,   148,   151,   152,   155,   158,   161,
   162,   163,   164,   166,   169,   206,   207,   210,   242,   243,
   246,   250,   254,   258,   269,   273,   274,   275,   276,   280,
   283,   286,   289,   290,   293,   294,   297,   298,   302,   305,
   308,   311,   314
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TASK","MODNAME",
"CHILD","IRQ","MAX","IN","MASK","MEMORY","HIMEM","LOGMCP","BOOTMCP","BOOTPRIO",
"BOOTWAIT","RMGR","SIGMA0","DEBUGFLAG","VERBOSE","LOG","SMALLSIZE","SMALL","BOOTSMALL",
"MODULE","TASK_PROTO","TASK_ALLOC","TASK_GET","TASK_FREE","TASK_CREATE","TASK_DELETE",
"TASK_SMALL","TASK_GET_ID","TASK_CREATE_WITH_PRIO","MEM_PROTO","MEM_FREE","MEM_FREE_FP",
"IRQ_PROTO","IRQ_GET","IRQ_FREE","RMGR_PROTO","RMGR_PING","LOG_IT","KDEBUG",
"UNSIGNED","STRING","'['","','","']'","file","rules","rule","smallsizerule",
"numerical_options","verbose_option","verbose_options","log_options","flag",
"modules","module","nextmod","taskspec","taskname","asserts","assert","constraints",
"constraint","childconstraints","smallconstraints","memoryconstraints","irqconstraints",
"numconstraints","numconstraint","setspec","maskconstraints","maskconstraint",
"number","string", NULL
};
#endif

static const short yyr1[] = {     0,
    49,    50,    50,    51,    51,    51,    52,    53,    54,    54,
    54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
    54,    54,    54,    54,    54,    54,    54,    55,    55,    56,
    56,    57,    57,    57,    57,    58,    58,    59,    60,    61,
    61,    61,    61,    61,    62,    63,    63,    64,    65,    65,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    67,
    68,    69,    70,    70,    71,    71,    72,    72,    73,    74,
    75,    76,    77
};

static const short yyr2[] = {     0,
     1,     2,     0,     3,     1,     1,     2,     2,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
     1,     1,     1,     1,     2,     2,     0,     2,     1,     1,
     2,     2,     2,     2,     2,     2,     0,     2,     2,     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
     1,     1,     1,     1,     2,     1,     2,     2,     5,     1,
     2,     1,     1
};

static const short yydefact[] = {     3,
    40,    32,    34,    33,     0,     0,     1,     3,     5,     6,
    50,     0,    42,    43,    72,    41,    44,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    30,    29,    31,    35,
     0,     7,     2,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    37,    50,    73,    45,    28,     8,     0,     0,
    51,    60,    66,     0,    54,    63,    64,    70,    52,    62,
    53,    56,    57,    58,    55,    61,    59,    39,     4,    37,
    47,    49,    67,     0,    68,    65,    71,    36,     0,    38,
    47,     0,    48,    46,     0,     0,    69,     0,     0,     0
};

static const short yydefgoto[] = {    98,
     7,     8,     9,    37,    38,    39,    40,    10,    79,    80,
    81,    11,    16,    90,    91,    53,    54,    61,    75,    69,
    65,    70,    63,    85,    67,    68,    17,    56
};

static const short yypact[] = {    57,
    -2,-32768,-32768,-32768,    -9,   -36,-32768,    57,-32768,-32768,
    51,   -35,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    66,-32768,-32768,
   -36,-32768,-32768,    -1,    -4,    -1,    -1,   -36,   -36,   -36,
    -1,   -36,   -15,    51,-32768,-32768,-32768,-32768,   -36,   -34,
-32768,-32768,    -1,   -36,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -15,
     7,-32768,-32768,   -36,-32768,-32768,-32768,-32768,   -35,-32768,
     7,   -10,-32768,-32768,   -36,    -8,-32768,    13,    38,-32768
};

static const short yypgoto[] = {-32768,
    31,-32768,-32768,-32768,-32768,     3,-32768,-32768,   -30,-32768,
-32768,-32768,-32768,   -45,-32768,    -3,-32768,-32768,-32768,     5,
-32768,     4,-32768,-32768,-32768,-32768,    -5,   -31
};


#define	YYLAST		109


static const short yytable[] = {    41,
    42,    12,    59,    60,    64,    59,    60,    15,    78,    55,
    89,    84,    99,    13,    14,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    15,    58,    95,   100,    43,    97,
    57,    15,    72,    73,    74,    94,    77,    62,    66,    88,
    82,    71,     0,    83,    76,    44,    45,    93,    87,     1,
    46,    47,    48,    49,    50,     0,    86,     0,     0,     0,
     0,     2,    51,    52,     3,     4,     5,     6,    92,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    96,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36
};

static const short yycheck[] = {     5,
     6,     4,     7,     8,     9,     7,     8,    44,    24,    45,
     4,    46,     0,    16,    17,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    41,    47,     0,     8,    48,
    38,    44,    48,    49,    50,    91,    52,    44,    45,    80,
    54,    47,    -1,    59,    51,     5,     6,    89,    64,     3,
    10,    11,    12,    13,    14,    -1,    63,    -1,    -1,    -1,
    -1,    15,    22,    23,    18,    19,    20,    21,    84,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
    25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
YYPARSE_RETURN_TYPE yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 4:
#line 75 "cfg-parse.y"
{ 
					  if (ctask)
					    {
					      quota_t *q = & quota[ctask];
					      bootquota_t *b = 
					        & bootquota[ctask];
					      printf("RMGR: configured "
						     "task 0x%x: "
						     "[ m:%x,%x,%x "
						     "hm:%x,%x,%x\n      "
						     "t:%x,%x,%x "
						     "i:%x lmcp:%x "
						     "s:%x,%x,%x\n      "
						     "mcp:%x prio:%x "
						     "small:%x ]\n", 
						     ctask,
						     q->mem.low, q->mem.high,
						     q->mem.max, q->himem.low, 
						     q->himem.high, 
						     q->himem.max, 
						     q->task.low,
						     q->task.high, q->task.max,
						     q->irq.max, q->log_mcp,
						     q->small.low, 
						     q->small.high,
						     q->small.max,
						     b->mcp, b->prio, 
						     b->small_space);
					    }
				          assert_mod = -1;
					;
    break;}
case 7:
#line 111 "cfg-parse.y"
{ small_space_size = yyvsp[0].number; ;
    break;}
case 8:
#line 113 "cfg-parse.y"
{ debug_log_mask = yyvsp[-1].number;
					  debug_log_types = yyvsp[0].number; ;
    break;}
case 9:
#line 116 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, 0); ;
    break;}
case 10:
#line 117 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_ALLOC); ;
    break;}
case 11:
#line 118 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_GET); ;
    break;}
case 12:
#line 119 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_FREE); ;
    break;}
case 13:
#line 120 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_CREATE); ;
    break;}
case 14:
#line 121 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_DELETE); ;
    break;}
case 15:
#line 122 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_SET_SMALL); ;
    break;}
case 16:
#line 123 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_GET_ID); ;
    break;}
case 17:
#line 124 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_TASK, RMGR_TASK_CREATE_WITH_PRIO); ;
    break;}
case 18:
#line 125 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_MEM, 0); ;
    break;}
case 19:
#line 126 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_MEM, RMGR_MEM_FREE); ;
    break;}
case 20:
#line 127 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_MEM, RMGR_MEM_FREE_FP); ;
    break;}
case 21:
#line 128 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_IRQ, 0); ;
    break;}
case 22:
#line 129 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_IRQ, RMGR_IRQ_GET); ;
    break;}
case 23:
#line 130 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_IRQ, RMGR_IRQ_FREE); ;
    break;}
case 24:
#line 131 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_IRQ, 0); ;
    break;}
case 25:
#line 132 "cfg-parse.y"
{ SET_DEBUG_OPT(RMGR_IRQ, RMGR_RMGR_PING); ;
    break;}
case 26:
#line 133 "cfg-parse.y"
{ debug_log_types |= 1; ;
    break;}
case 27:
#line 134 "cfg-parse.y"
{ debug_log_types |= 4; ;
    break;}
case 32:
#line 145 "cfg-parse.y"
{ boot_wait++; ;
    break;}
case 33:
#line 146 "cfg-parse.y"
{ verbose++; ;
    break;}
case 34:
#line 147 "cfg-parse.y"
{ debug++; ;
    break;}
case 38:
#line 155 "cfg-parse.y"
{ bootquota[ctask].mods++; ;
    break;}
case 39:
#line 158 "cfg-parse.y"
{ assert_mod++; ;
    break;}
case 40:
#line 161 "cfg-parse.y"
{ ctask = ++ __cfg_task; ;
    break;}
case 42:
#line 163 "cfg-parse.y"
{ ctask = __cfg_task = myself.id.task;;
    break;}
case 43:
#line 164 "cfg-parse.y"
{ ctask = __cfg_task 
						= my_pager.id.task; ;
    break;}
case 44:
#line 166 "cfg-parse.y"
{ ctask = __cfg_task = yyvsp[0].number; ;
    break;}
case 45:
#line 169 "cfg-parse.y"
{ char *n;
					  int i;
					  for (i = first_task_module;
					       i < mb_info.mods_count;
					       i++)
					    {
					      n = (char *) mb_mod[i].string;
					      if (! n)
					        {
						  ctask = ++ __cfg_task;
					          printf("RMGR: WARNING: "
						         "cmdlines "
						         "unsupported, can't "
						         "find modname %s;"
							 "assuming task %d\n",
						         yyvsp[0].string, ctask);
						  goto taskname_end;
						}
					      if (strstr(n, yyvsp[0].string))
					        {
						  ctask = __cfg_task =
						    myself.id.task + 1 
						    + (i - first_task_module);
						  assert_mod = i;
						  goto taskname_end;
						}
					    }
					  ctask = 0;
					  printf("RMGR: WARNING: "
						 "couldn't find modname %s; "
						 "ignoring configuration\n",
						 yyvsp[0].string);

					taskname_end:
					  free(yyvsp[0].string);
					;
    break;}
case 48:
#line 210 "cfg-parse.y"
{ char *n;
					  if (assert_mod < 1)
					    {
					      printf("RMGR: ERROR: no boot "
					             "module associated with "
						     "modname %s\n",
						     yyvsp[0].string);
					      boot_errors++;
					      goto assert_end;
					    }
					  n = (char *)
					    mb_mod[assert_mod].string;
					  if (! n)
					    {
					      printf("RMGR: WARNING: cmdlines "
						     "unsupported, can't "
						     "verify modname %s\n",
						     yyvsp[0].string);
					    }
					  else if (! strstr(n, yyvsp[0].string))
					    {
					      printf("RMGR: ERROR: modname "
						     "%s doesn't match "
						     "cmdline %s\n",
						     yyvsp[0].string, n);
					      boot_errors++;
					    }
					assert_end:
					  free(yyvsp[0].string);
					;
    break;}
case 51:
#line 246 "cfg-parse.y"
{ maxset(quota[ctask].task.low, c_low);
					  minset(quota[ctask].task.high, c_high);
					  minset(quota[ctask].task.max, c_max);
                                          c_low = 0; c_high = -1; c_max = -1; ;
    break;}
case 52:
#line 250 "cfg-parse.y"
{ maxset(quota[ctask].mem.low, c_low);
					  minset(quota[ctask].mem.high, c_high);
					  minset(quota[ctask].mem.max, c_max);
                                          c_low = 0; c_high = -1; c_max = -1; ;
    break;}
case 53:
#line 254 "cfg-parse.y"
{ maxset(quota[ctask].himem.low, c_low);
					  minset(quota[ctask].himem.high, c_high);
					  minset(quota[ctask].himem.max, c_max);
                                          c_low = 0; c_high = -1; c_max = -1; ;
    break;}
case 54:
#line 258 "cfg-parse.y"
{ unsigned mask = 0, i;
					  for (i = max(0, c_low);
					       i <= min(15, c_max);
					       i++)
					    {
                                              mask |= 1L << i;
					    }
					  quota[ctask].irq.max &= 
					    c_mask & mask;
                                          c_low = 0; c_high = -1; c_max = -1;
					  c_mask = 0xffffffff; ;
    break;}
case 55:
#line 269 "cfg-parse.y"
{ maxset(quota[ctask].small.low, c_low);
					  minset(quota[ctask].small.high, c_high);
					  minset(quota[ctask].small.max, c_max);
                                          c_low = 0; c_high = -1; c_max = -1; ;
    break;}
case 56:
#line 273 "cfg-parse.y"
{ quota[ctask].log_mcp = yyvsp[0].number; ;
    break;}
case 57:
#line 274 "cfg-parse.y"
{ bootquota[ctask].mcp = yyvsp[0].number; ;
    break;}
case 58:
#line 275 "cfg-parse.y"
{ bootquota[ctask].prio = yyvsp[0].number; ;
    break;}
case 59:
#line 276 "cfg-parse.y"
{ bootquota[ctask].small_space
					    = yyvsp[0].number; ;
    break;}
case 67:
#line 297 "cfg-parse.y"
{ c_max = min(c_max, yyvsp[0].number); ;
    break;}
case 68:
#line 298 "cfg-parse.y"
{ c_low = max(c_low, yyvsp[0].interval.low); 
					  c_high = min(c_high, yyvsp[0].interval.high); ;
    break;}
case 69:
#line 302 "cfg-parse.y"
{ yyval.interval.low = yyvsp[-3].number; yyval.interval.high = yyvsp[-1].number; ;
    break;}
case 71:
#line 308 "cfg-parse.y"
{ c_mask &= yyvsp[0].number; ;
    break;}
case 72:
#line 311 "cfg-parse.y"
{ yyval.number = strtoul(yyvsp[0].string, 0, 0); ;
    break;}
case 73:
#line 314 "cfg-parse.y"
{ yyval.string = strdup(yyvsp[0].string + 1);
					  yyval.string[strlen(yyval.string) - 1] = 0; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 317 "cfg-parse.y"

/* end of grammer -- misc C source code follows */

#include "cfg-scan.c"

static void yyerror(const char *s)
{
  printf("RMGR: ERROR: while parsing config file: %s\n"
	 "             at line %d, col %d\n", s, line, col);
}


#ifdef TEST

char cfg[] = "task modname 'foo'\n"
             "#a comment\n"
             "child in [10,30] max 100\n";

int main(void)
{
  cfg_setup_input(cfg, cfg + sizeof(cfg));

  return cfg_parse();
}

#endif /* TEST */
